Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/Chart.cs	(revision 13045)
@@ -23,5 +23,4 @@
 using System.Collections.Generic;
 using System.Drawing;
-using System.Linq;
 using System.Windows.Forms;
 
@@ -30,14 +29,19 @@
     private PointD originalLowerLeft;
     private PointD originalUpperRight;
-    private List<Offset> zoomHistory;
-
-    private ChartMode myMode;
-    public virtual ChartMode Mode {
-      get { return myMode; }
+    protected List<Offset> zoomHistory;
+
+    private bool enabled;
+    public bool Enabled {
+      get { return enabled; }
       set {
-        myMode = value;
-        OnUpdate();
-      }
-    }
+        if (enabled == value) return;
+        enabled = value;
+        OnRedrawRequired();
+      }
+    }
+
+    protected bool SuppressRedraw { get; set; }
+
+    public bool SuppressEvents { get; set; }
 
     private PointD myLowerLeft;
@@ -53,4 +57,5 @@
     }
     private Size mySizeInPixels;
+
     public Size SizeInPixels {
       get { return mySizeInPixels; }
@@ -62,48 +67,42 @@
       get { return new SizeD(SizeInPixels.Width / Size.Width, SizeInPixels.Height / Size.Height); }
     }
-
-    private IGroup myGroup;
-    public IGroup Group {
-      get { return myGroup; }
-    }
-
-    private bool myUpdateEnabled;
-    public bool UpdateEnabled {
-      get { return myUpdateEnabled; }
-      set { myUpdateEnabled = value; }
-    }
+    public double Scale { get; set; }
+    public double MinimumZoomDistance { get; set; }
+    public IGroup Group { get; protected set; }
 
     public Chart(PointD lowerLeft, PointD upperRight) {
-      myUpdateEnabled = false;
       zoomHistory = new List<Offset>();
-      myMode = ChartMode.Move;
       SetPosition(lowerLeft, upperRight);
-      mySizeInPixels = new Size(100, 100);
-      myGroup = new Group(this);
-      Group.Update += new EventHandler(Group_Update);
-      myUpdateEnabled = true;
-    }
+      mySizeInPixels = new Size((int)Size.Width, (int)Size.Height);
+      Scale = 1.0;
+      Group = new Group(this);
+      Group.RedrawRequired += GroupOnRedrawRequired;
+      MinimumZoomDistance = 0.01;
+    }
+
     public Chart(double x1, double y1, double x2, double y2)
-      : this(new PointD(x1, y1), new PointD(x2, y2)) {
-    }
+      : this(new PointD(x1, y1), new PointD(x2, y2)) { }
 
     public PointD TransformPixelToWorld(Point point) {
-      double x = LowerLeft.X + point.X * PixelToWorldRatio.Width;
-      double y = LowerLeft.Y + (SizeInPixels.Height - point.Y) * PixelToWorldRatio.Height;
+      var x = LowerLeft.X + point.X * PixelToWorldRatio.Width;
+      var y = LowerLeft.Y + (SizeInPixels.Height - point.Y) * PixelToWorldRatio.Height;
       return new PointD(x, y);
     }
+
     public SizeD TransformPixelToWorld(Size size) {
-      double width = size.Width * PixelToWorldRatio.Width;
-      double height = size.Height * PixelToWorldRatio.Height;
+      var width = size.Width * PixelToWorldRatio.Width;
+      var height = size.Height * PixelToWorldRatio.Height;
       return new SizeD(width, height);
     }
+
     public Point TransformWorldToPixel(PointD point) {
-      int x = (int)((point.X - LowerLeft.X) * WorldToPixelRatio.Width);
-      int y = (int)((UpperRight.Y - point.Y) * WorldToPixelRatio.Height);
+      var x = (int)((point.X - LowerLeft.X) * WorldToPixelRatio.Width);
+      var y = (int)((UpperRight.Y - point.Y) * WorldToPixelRatio.Height);
       return new Point(x, y);
     }
+
     public Size TransformWorldToPixel(SizeD size) {
-      int width = (int)(size.Width * WorldToPixelRatio.Width);
-      int height = (int)(size.Height * WorldToPixelRatio.Height);
+      var width = (int)(size.Width * WorldToPixelRatio.Width);
+      var height = (int)(size.Height * WorldToPixelRatio.Height);
       return new Size(width, height);
     }
@@ -118,34 +117,61 @@
       myLowerLeft = lowerLeft;
       myUpperRight = upperRight;
-      OnUpdate();
-    }
-    public void SetPosition(double x1, double y1, double x2, double y2) {
-      SetPosition(new PointD(x1, y1), new PointD(x2, y2));
-    }
+      OnRedrawRequired();
+    }
+
     public virtual void Move(Offset delta) {
       myLowerLeft += delta;
       myUpperRight += delta;
-      OnUpdate();
-    }
-    public void Move(double dx, double dy) {
-      Move(new Offset(dx, dy));
+      OnRedrawRequired();
+    }
+
+    public virtual void Zoom(Point mousePosition, double delta) {
+      var cursor = TransformPixelToWorld(mousePosition);
+
+      double zoomLevel = (100 + delta) / 100;
+      double width = this.UpperRight.X - this.LowerLeft.X;
+      double height = this.UpperRight.Y - this.LowerLeft.Y;
+      double newWidth = width * zoomLevel;
+      double newHeight = height * zoomLevel;
+      double xAdaption = (UpperRight.X - cursor.X) / width;
+      double yAdaption = (UpperRight.Y - cursor.Y) / height;
+
+      ZoomIn(new PointD(cursor.X - newWidth * (1 - xAdaption), cursor.Y - newHeight * (1 - yAdaption)), new PointD(cursor.X + newWidth * xAdaption, cursor.Y + newHeight * yAdaption));
+      OnRedrawRequired();
+    }
+
+    public virtual void ZoomIn(Point mousePosition) {
+      Zoom(mousePosition, -10);
     }
 
     public virtual void ZoomIn(PointD lowerLeft, PointD upperRight) {
+      // maintain a 1:1 ratio between x and y axis
+      var pixels = SizeInPixels;
+      var diagonal = upperRight - lowerLeft;
+      var windowRatio = pixels.Height / (double)pixels.Width;
+      var viewRatio = diagonal.DY / diagonal.DX;
+      if (viewRatio < windowRatio) {
+        var neededHeight = windowRatio * diagonal.DX;
+        var diff = (neededHeight - diagonal.DY) / 2.0;
+        lowerLeft.Y -= diff;
+        upperRight.Y += diff;
+      } else {
+        var neededWidth = diagonal.DY / windowRatio;
+        var diff = (neededWidth - diagonal.DX) / 2.0;
+        lowerLeft.X -= diff;
+        upperRight.X += diff;
+      }
+      if ((lowerLeft - upperRight).Length < MinimumZoomDistance) return;
       zoomHistory.Insert(0, LowerLeft - lowerLeft);
       zoomHistory.Insert(0, UpperRight - upperRight);
       myLowerLeft = lowerLeft;
       myUpperRight = upperRight;
-      OnUpdate();
-    }
-    public void ZoomIn(double x1, double y1, double x2, double y2) {
-      ZoomIn(new PointD(x1, y1), new PointD(x2, y2));
-    }
+      OnRedrawRequired();
+    }
+
     public virtual void ZoomIn(Point lowerLeft, Point upperRight) {
       ZoomIn(TransformPixelToWorld(lowerLeft), TransformPixelToWorld(upperRight));
     }
-    public void ZoomIn(int x1, int y1, int x2, int y2) {
-      ZoomIn(new Point(x1, y1), new Point(x2, y2));
-    }
+
     public virtual void ZoomOut() {
       if (zoomHistory.Count > 0) {
@@ -156,101 +182,46 @@
         myLowerLeft = LowerLeft + lowerLeft;
         myUpperRight = UpperRight + upperRight;
-        OnUpdate();
+        OnRedrawRequired();
       } else {
-        myLowerLeft.X -= Size.Width / 4;
-        myLowerLeft.Y -= Size.Height / 4;
-        myUpperRight.X += Size.Width / 4;
-        myUpperRight.Y += Size.Height / 4;
-        OnUpdate();
-      }
-    }
+        var lowerLeft = new PointD(myLowerLeft.X - Size.Width / 4, myLowerLeft.Y - Size.Height / 4);
+        var upperRight = new PointD(myUpperRight.X + Size.Width / 4, myUpperRight.Y + Size.Height / 4);
+        ZoomIn(lowerLeft, upperRight);
+        if (zoomHistory.Count >= 2) {
+          zoomHistory.RemoveRange(0, 2);
+        }
+      }
+    }
+
     public virtual void Unzoom() {
       SetPosition(originalLowerLeft, originalUpperRight);
     }
 
+    public virtual void IntoForeground(IPrimitive primitive) {
+      Group.IntoForeground(primitive);
+    }
+    public virtual void IntoBackground(IPrimitive primitive) {
+      Group.IntoBackground(primitive);
+    }
+    public virtual void OneLayerUp(IPrimitive primitive) {
+      Group.OneLayerUp(primitive);
+    }
+    public virtual void OneLayerDown(IPrimitive primitive) {
+      Group.OneLayerDown(primitive);
+    }
+
+    public virtual Cursor GetCursor(Point point) {
+      return Group.GetCursor(TransformPixelToWorld(point)) ?? Cursors.Default;
+    }
+
+    public virtual string GetToolTipText(Point point) {
+      return Group.GetToolTipText(TransformPixelToWorld(point));
+    }
+
     public virtual IPrimitive GetPrimitive(Point point) {
       return Group.GetPrimitive(TransformPixelToWorld(point));
     }
-    public IPrimitive GetPrimitive(int x, int y) {
-      return GetPrimitive(new Point(x, y));
-    }
-    public virtual IList<IPrimitive> GetAllPrimitives(Point point) {
+
+    public virtual IEnumerable<IPrimitive> GetAllPrimitives(Point point) {
       return Group.GetAllPrimitives(TransformPixelToWorld(point));
-    }
-    public IList<IPrimitive> GetAllPrimitives(int x, int y) {
-      return GetAllPrimitives(new Point(x, y));
-    }
-
-    public virtual Cursor GetCursor(Point point) {
-      Cursor cursor = Group.GetCursor(TransformPixelToWorld(point));
-      if (cursor != null) return cursor;
-
-      if (Mode == ChartMode.Move) return Cursors.Hand;
-      if (Mode == ChartMode.Select) return Cursors.Arrow;
-      if (Mode == ChartMode.Zoom) return Cursors.Arrow;
-      return Cursors.Default;
-    }
-    public Cursor GetCursor(int x, int y) {
-      return GetCursor(new Point(x, y));
-    }
-    public virtual string GetToolTipText(Point point) {
-      return Group.GetToolTipText(TransformPixelToWorld(point));
-    }
-    public string GetToolTipText(int x, int y) {
-      return GetToolTipText(new Point(x, y));
-    }
-
-    public virtual void MouseClick(Point point, MouseButtons button) {
-      if (Mode == ChartMode.Select) {
-        if (button == MouseButtons.Left) {
-          IPrimitive clicked = GetPrimitive(point);
-          UpdateEnabled = false;
-          foreach (IPrimitive primitive in Group.SelectedPrimitives)
-            primitive.Selected = false;
-          UpdateEnabled = true;
-          if (clicked != null) {
-            PointD p = TransformPixelToWorld(point);
-            clicked.MouseClick(p, button);
-          } else OnUpdate();
-        }
-      } else if (Mode == ChartMode.Move) {
-        if (button == MouseButtons.Middle) {
-          PointD center = LowerLeft + new Offset(Size.Width / 2, Size.Height / 2);
-          Move(TransformPixelToWorld(point) - center);
-        }
-      }
-    }
-    public void MouseClick(int x, int y, MouseButtons button) {
-      MouseClick(new Point(x, y), button);
-    }
-    public virtual void MouseDoubleClick(Point point, MouseButtons button) {
-    }
-    public void MouseDoubleClick(int x, int y, MouseButtons button) {
-      MouseDoubleClick(new Point(x, y), button);
-    }
-    public virtual void MouseMove(Point start, Point end) {
-    }
-    public void MouseMove(int x1, int y1, int x2, int y2) {
-      MouseMove(new Point(x1, y1), new Point(x2, y2));
-    }
-    public virtual void MouseDrag(Point start, Point end, MouseButtons button) {
-      PointD p1 = TransformPixelToWorld(start);
-      PointD p2 = TransformPixelToWorld(end);
-      Offset offset = p2 - p1;
-      if (Mode == ChartMode.Move) {
-        Move(-1 * offset.DX, -1 * offset.DY);
-      } else if (Mode == ChartMode.Select) {
-        if (button == MouseButtons.Left) {
-          IList<IPrimitive> selected = Group.SelectedPrimitives.Where(p => p.ContainsPoint(p1)).ToList();
-          UpdateEnabled = false;
-          foreach (IPrimitive primitive in selected)
-            primitive.MouseDrag(p1, offset, button);
-          UpdateEnabled = true;
-          OnUpdate();
-        }
-      }
-    }
-    public void MouseDrag(int x1, int y1, int x2, int y2, MouseButtons button) {
-      MouseDrag(new Point(x1, y1), new Point(x2, y2), button);
     }
 
@@ -260,19 +231,26 @@
       Group.Draw(graphics);
       Group.PostDraw(graphics);
-    }
-
-    public event EventHandler Update;
-    public void EnforceUpdate() {
-      if (Update != null) {
-        Update(this, new EventArgs());
-      }
-    }
-    protected virtual void OnUpdate() {
-      if ((UpdateEnabled) && (Update != null)) {
-        Update(this, new EventArgs());
-      }
-    }
-    private void Group_Update(object sender, EventArgs e) {
-      OnUpdate();
+      if (!enabled) {
+        var disabledColor = Color.FromArgb(150, SystemColors.Control);
+        var brush = new SolidBrush(disabledColor);
+        var rectangle = new System.Drawing.Rectangle(new Point(0, 0), mySizeInPixels);
+        graphics.FillRectangle(brush, rectangle);
+      }
+    }
+
+    public event EventHandler RedrawRequired;
+    protected virtual void OnRedrawRequired() {
+      if (SuppressRedraw) return;
+      var handler = RedrawRequired;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    public void RaiseRedrawRequired() {
+      var handler = RedrawRequired;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    private void GroupOnRedrawRequired(object sender, EventArgs e) {
+      OnRedrawRequired();
     }
   }
Index: branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs
===================================================================
--- branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs	(revision 12537)
+++ branches/HeuristicLab.Visualization/HeuristicLab.Visualization/3.3/ChartControl.Designer.cs	(revision 13045)
@@ -48,19 +48,22 @@
       this.pictureBox = new System.Windows.Forms.PictureBox();
       this.pictureBoxContextMenuStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
-      this.moveToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.zoomToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.selectToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.toolStripMenuItem1 = new System.Windows.Forms.ToolStripSeparator();
       this.oneLayerUpToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.oneLayerDownToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.intoForegroundToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.intoBackgroundToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.toolStripMenuItem1 = new System.Windows.Forms.ToolStripSeparator();
+      this.propertiesToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.selectButton = new System.Windows.Forms.RadioButton();
+      this.moveButton = new System.Windows.Forms.RadioButton();
+      this.zoomInButton = new System.Windows.Forms.RadioButton();
+      this.zoomOutButton = new System.Windows.Forms.RadioButton();
+      this.buttonPanel = new System.Windows.Forms.FlowLayoutPanel();
+      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
+      this.saveImageToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.toolStripMenuItem2 = new System.Windows.Forms.ToolStripSeparator();
-      this.propertiesToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.saveImageToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
-      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
-      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
       ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
       this.pictureBoxContextMenuStrip.SuspendLayout();
+      this.buttonPanel.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -71,63 +74,39 @@
             | System.Windows.Forms.AnchorStyles.Right)));
       this.pictureBox.BackColor = System.Drawing.Color.White;
+      this.pictureBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
       this.pictureBox.ContextMenuStrip = this.pictureBoxContextMenuStrip;
-      this.pictureBox.Location = new System.Drawing.Point(0, 0);
+      this.pictureBox.Location = new System.Drawing.Point(35, 0);
       this.pictureBox.Name = "pictureBox";
-      this.pictureBox.Size = new System.Drawing.Size(266, 236);
+      this.pictureBox.Size = new System.Drawing.Size(685, 500);
       this.pictureBox.TabIndex = 0;
       this.pictureBox.TabStop = false;
-      this.pictureBox.SizeChanged += new System.EventHandler(this.pictureBox_SizeChanged);
-      this.pictureBox.VisibleChanged += new System.EventHandler(this.pictureBox_VisibleChanged);
-      this.pictureBox.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseDown);
-      this.pictureBox.MouseEnter += new System.EventHandler(this.pictureBox_MouseEnter);
-      this.pictureBox.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseMove);
-      this.pictureBox.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseUp);
-      this.pictureBox.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.pictureBox_MouseWheel);
-
+      this.pictureBox.KeyUp += new System.Windows.Forms.KeyEventHandler(this.OnKeyUp);
+      this.pictureBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.OnKeyDown);
+      this.pictureBox.SizeChanged += new System.EventHandler(this.PictureBoxOnSizeChanged);
+      this.pictureBox.VisibleChanged += new System.EventHandler(this.PictureBoxOnVisibleChanged);
+      this.pictureBox.Click += new System.EventHandler(this.PictureBoxOnClick);
+      this.pictureBox.MouseClick += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseClick);
+      this.pictureBox.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseDoubleClick);
+      this.pictureBox.MouseDown += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseDown);
+      this.pictureBox.MouseEnter += new System.EventHandler(this.PictureBoxOnMouseEnter);
+      this.pictureBox.MouseLeave += new System.EventHandler(this.PictureBoxOnMouseLeave);
+      this.pictureBox.MouseMove += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseMove);
+      this.pictureBox.MouseUp += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseUp);
+      this.pictureBox.MouseWheel += new System.Windows.Forms.MouseEventHandler(this.PictureBoxOnMouseWheel);
       // 
       // pictureBoxContextMenuStrip
       // 
       this.pictureBoxContextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
-            this.moveToolStripMenuItem,
-            this.zoomToolStripMenuItem,
-            this.selectToolStripMenuItem,
-            this.toolStripMenuItem1,
             this.oneLayerUpToolStripMenuItem,
             this.oneLayerDownToolStripMenuItem,
             this.intoForegroundToolStripMenuItem,
             this.intoBackgroundToolStripMenuItem,
+            this.toolStripMenuItem1,
+            this.propertiesToolStripMenuItem,
             this.toolStripMenuItem2,
-            this.propertiesToolStripMenuItem,
             this.saveImageToolStripMenuItem});
       this.pictureBoxContextMenuStrip.Name = "pictureBoxContextMenuStrip";
-      this.pictureBoxContextMenuStrip.Size = new System.Drawing.Size(163, 214);
-      // 
-      // moveToolStripMenuItem
-      // 
-      this.moveToolStripMenuItem.Checked = true;
-      this.moveToolStripMenuItem.CheckState = System.Windows.Forms.CheckState.Checked;
-      this.moveToolStripMenuItem.Name = "moveToolStripMenuItem";
-      this.moveToolStripMenuItem.Size = new System.Drawing.Size(162, 22);
-      this.moveToolStripMenuItem.Text = "&Move";
-      this.moveToolStripMenuItem.Click += new System.EventHandler(this.moveToolStripMenuItem_Click);
-      // 
-      // zoomToolStripMenuItem
-      // 
-      this.zoomToolStripMenuItem.Name = "zoomToolStripMenuItem";
-      this.zoomToolStripMenuItem.Size = new System.Drawing.Size(162, 22);
-      this.zoomToolStripMenuItem.Text = "&Zoom";
-      this.zoomToolStripMenuItem.Click += new System.EventHandler(this.zoomToolStripMenuItem_Click);
-      // 
-      // selectToolStripMenuItem
-      // 
-      this.selectToolStripMenuItem.Name = "selectToolStripMenuItem";
-      this.selectToolStripMenuItem.Size = new System.Drawing.Size(162, 22);
-      this.selectToolStripMenuItem.Text = "&Select";
-      this.selectToolStripMenuItem.Click += new System.EventHandler(this.selectToolStripMenuItem_Click);
-      // 
-      // toolStripMenuItem1
-      // 
-      this.toolStripMenuItem1.Name = "toolStripMenuItem1";
-      this.toolStripMenuItem1.Size = new System.Drawing.Size(159, 6);
+      this.pictureBoxContextMenuStrip.Size = new System.Drawing.Size(163, 170);
+      this.pictureBoxContextMenuStrip.Opening += new System.ComponentModel.CancelEventHandler(this.PictureBoxContextMenuStripOnOpening);
       // 
       // oneLayerUpToolStripMenuItem
@@ -163,8 +142,8 @@
       this.intoBackgroundToolStripMenuItem.Click += new System.EventHandler(this.intoBackgroundToolStripMenuItem_Click);
       // 
-      // toolStripMenuItem2
-      // 
-      this.toolStripMenuItem2.Name = "toolStripMenuItem2";
-      this.toolStripMenuItem2.Size = new System.Drawing.Size(159, 6);
+      // toolStripMenuItem1
+      // 
+      this.toolStripMenuItem1.Name = "toolStripMenuItem1";
+      this.toolStripMenuItem1.Size = new System.Drawing.Size(159, 6);
       // 
       // propertiesToolStripMenuItem
@@ -176,9 +155,14 @@
       this.propertiesToolStripMenuItem.Click += new System.EventHandler(this.propertiesToolStripMenuItem_Click);
       // 
+      // toolStripMenuItem2
+      // 
+      this.toolStripMenuItem2.Name = "toolStripMenuItem2";
+      this.toolStripMenuItem2.Size = new System.Drawing.Size(159, 6);
+      // 
       // saveImageToolStripMenuItem
       // 
       this.saveImageToolStripMenuItem.Name = "saveImageToolStripMenuItem";
       this.saveImageToolStripMenuItem.Size = new System.Drawing.Size(162, 22);
-      this.saveImageToolStripMenuItem.Text = "Save Image";
+      this.saveImageToolStripMenuItem.Text = "&Save Image";
       this.saveImageToolStripMenuItem.Click += new System.EventHandler(this.saveImageToolStripMenuItem_Click);
       // 
@@ -187,17 +171,91 @@
       this.saveFileDialog.DefaultExt = "emf";
       this.saveFileDialog.FileName = "*.emf";
-      this.saveFileDialog.Filter = "Enhanced metafile|*.emf|Bitmap files|*.bmp";
+      this.saveFileDialog.Filter = "Bitmap (*.bmp)|*.bmp|JPEG (*.jpg)|*.jpg|EMF (*.emf)|*.emf|PNG (*.png)|*.png|GIF (" +
+    "*.gif)|*.gif|TIFF (*.tif)|*.tif";
+      // 
+      // selectButton
+      // 
+      this.selectButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.selectButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Pointer;
+      this.selectButton.Location = new System.Drawing.Point(3, 3);
+      this.selectButton.Name = "selectButton";
+      this.selectButton.Size = new System.Drawing.Size(26, 24);
+      this.selectButton.TabIndex = 1;
+      this.selectButton.TabStop = true;
+      this.selectButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.toolTip.SetToolTip(this.selectButton, "Select");
+      this.selectButton.UseVisualStyleBackColor = true;
+      this.selectButton.CheckedChanged += new System.EventHandler(this.SelectButtonOnCheckedChanged);
+      // 
+      // moveButton
+      // 
+      this.moveButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.moveButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Breakpoint;
+      this.moveButton.Location = new System.Drawing.Point(3, 33);
+      this.moveButton.Name = "moveButton";
+      this.moveButton.Size = new System.Drawing.Size(26, 24);
+      this.moveButton.TabIndex = 1;
+      this.moveButton.TabStop = true;
+      this.moveButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.toolTip.SetToolTip(this.moveButton, "Move");
+      this.moveButton.UseVisualStyleBackColor = true;
+      this.moveButton.CheckedChanged += new System.EventHandler(this.MoveButtonOnCheckedChanged);
+      // 
+      // zoomInButton
+      // 
+      this.zoomInButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.zoomInButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.ZoomIn;
+      this.zoomInButton.Location = new System.Drawing.Point(3, 63);
+      this.zoomInButton.Name = "zoomInButton";
+      this.zoomInButton.Size = new System.Drawing.Size(26, 24);
+      this.zoomInButton.TabIndex = 1;
+      this.zoomInButton.TabStop = true;
+      this.zoomInButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.toolTip.SetToolTip(this.zoomInButton, "Zoom In");
+      this.zoomInButton.UseVisualStyleBackColor = true;
+      this.zoomInButton.CheckedChanged += new System.EventHandler(this.ZoomInButtonOnCheckedChanged);
+      // 
+      // zoomOutButton
+      // 
+      this.zoomOutButton.Appearance = System.Windows.Forms.Appearance.Button;
+      this.zoomOutButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.ZoomOut;
+      this.zoomOutButton.Location = new System.Drawing.Point(3, 93);
+      this.zoomOutButton.Name = "zoomOutButton";
+      this.zoomOutButton.Size = new System.Drawing.Size(26, 24);
+      this.zoomOutButton.TabIndex = 1;
+      this.zoomOutButton.TabStop = true;
+      this.zoomOutButton.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
+      this.toolTip.SetToolTip(this.zoomOutButton, "Zoom Out");
+      this.zoomOutButton.UseVisualStyleBackColor = true;
+      this.zoomOutButton.CheckedChanged += new System.EventHandler(this.ZoomOutButtonOnCheckedChanged);
+      // 
+      // buttonPanel
+      // 
+      this.buttonPanel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)));
+      this.buttonPanel.Controls.Add(this.selectButton);
+      this.buttonPanel.Controls.Add(this.moveButton);
+      this.buttonPanel.Controls.Add(this.zoomInButton);
+      this.buttonPanel.Controls.Add(this.zoomOutButton);
+      this.buttonPanel.Location = new System.Drawing.Point(0, 0);
+      this.buttonPanel.Name = "buttonPanel";
+      this.buttonPanel.Size = new System.Drawing.Size(32, 500);
+      this.buttonPanel.TabIndex = 2;
       // 
       // ChartControl
       // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.BackColor = System.Drawing.SystemColors.Control;
+      this.Controls.Add(this.buttonPanel);
       this.Controls.Add(this.pictureBox);
+      this.DoubleBuffered = true;
       this.Name = "ChartControl";
-      this.Size = new System.Drawing.Size(266, 236);
-      this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.ChartControl_KeyDown);
+      this.Size = new System.Drawing.Size(720, 500);
+      this.Load += new System.EventHandler(this.ChartControl_Load);
+      this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.OnKeyDown);
+      this.KeyUp += new System.Windows.Forms.KeyEventHandler(this.OnKeyUp);
       ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).EndInit();
       this.pictureBoxContextMenuStrip.ResumeLayout(false);
+      this.buttonPanel.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -209,8 +267,5 @@
     protected System.Windows.Forms.ToolTip toolTip;
     protected System.Windows.Forms.ContextMenuStrip pictureBoxContextMenuStrip;
-    protected System.Windows.Forms.ToolStripMenuItem moveToolStripMenuItem;
-    protected System.Windows.Forms.ToolStripMenuItem zoomToolStripMenuItem;
-    protected System.Windows.Forms.ToolStripMenuItem selectToolStripMenuItem;
-    protected System.Windows.Forms.ToolStripSeparator toolStripMenuItem1;
+    protected System.Windows.Forms.ToolStripMenuItem saveImageToolStripMenuItem;
     protected System.Windows.Forms.ToolStripMenuItem propertiesToolStripMenuItem;
     protected System.Windows.Forms.ToolStripMenuItem oneLayerUpToolStripMenuItem;
@@ -218,8 +273,12 @@
     protected System.Windows.Forms.ToolStripMenuItem intoForegroundToolStripMenuItem;
     protected System.Windows.Forms.ToolStripMenuItem intoBackgroundToolStripMenuItem;
+    protected System.Windows.Forms.ToolStripSeparator toolStripMenuItem1;
     protected System.Windows.Forms.ToolStripSeparator toolStripMenuItem2;
-    private System.Windows.Forms.ToolStripMenuItem saveImageToolStripMenuItem;
-    private System.Windows.Forms.SaveFileDialog saveFileDialog;
-
+    protected System.Windows.Forms.RadioButton selectButton;
+    protected System.Windows.Forms.RadioButton moveButton;
+    protected System.Windows.Forms.RadioButton zoomInButton;
+    protected System.Windows.Forms.RadioButton zoomOutButton;
+    protected System.Windows.Forms.FlowLayoutPanel buttonPanel;
+    protected System.Windows.Forms.SaveFileDialog saveFileDialog;
   }
 }
